open Cmdliner

(* User-specified logging *)
let setup_log style_renderer level =
  Fmt_tty.setup_std_outputs ?style_renderer ();
  Logs.set_level level;
  Logs.set_reporter (Logs_fmt.reporter ());
  `LoggingIsConfigured

(* Common options term *)
let copts_t =
  let copts style_renderer level =
    let (_ : [ `LoggingIsConfigured ]) = setup_log style_renderer level in
    Copts.{ log_level = level }
  in
  let docs = Manpage.s_common_options in
  Term.(const copts $ Fmt_cli.style_renderer ~docs () $ Optslogs.level ~docs ())

(** Pretty term *)
let pretty_t =
  let doc =
    "Output in a \"pretty\" format rather than a minified format. There is a \
     pretty format for JSON and there is a pretty format for sexp. The pretty \
     format is not particularly pretty but it makes diffing much easier for \
     humans. You can also diff the minified format using `git diff \
     --word-diff`"
  in
  Arg.(value & flag & info ~doc [ "pretty" ])

(** JSON term *)
let json_t =
  let doc = "Output JSON rather than sexp." in
  Arg.(value & flag & info ~doc [ "json" ])

(** Change directory term *)
let chdir_t =
  let doc = "Change directory to the specified path." in
  let t =
    Arg.(value & opt (some dir) None & info ~doc [ "C"; "change-directory" ])
  in
  let t = Term.(const (Stdlib.Option.map Fpath.v) $ t) in
  (* supply default here not in [opt dir default] so doesn't pollute the manpage. *)
  let default = Fpath.v (Unix.getcwd ()) in
  Term.(const (Stdlib.Option.value ~default) $ t)

(** Output file term *)
let outfile_t =
  let doc = "Output .sig file" in
  let t =
    Arg.(
      required & pos 0 (some string) None & info ~doc ~docv:"SIG_OUTPUT_FILE" [])
  in
  Term.(const Fpath.v $ t)

(** Scan term *)
let scan_t =
  let enum =
    [
      (* The first entry is the default. Aka it is a hack for the option's absent rendering *)
      ("DkCoderProject", None);
      ("DkCoderRuntime", Some ExtractSig.DkCoderRuntime);
      ("DkCoderProject", Some ExtractSig.DkCoderProject);
    ]
  in
  let scan_type = Arg.enum enum in
  let enum_alts = Arg.doc_alts_enum List.(tl enum) in
  let doc =
    Printf.sprintf
      "Which libraries will be scanned for .cmi files. $(docv) influences \
       which libraries are scanned. DkCoderProject is the default. $(docv) \
       must be %s."
      enum_alts
  in
  let t =
    Arg.(value & opt scan_type None & info [ "scan" ] ~docv:"SCANTYPE" ~doc)
  in
  Term.(const (Stdlib.Option.value ~default:ExtractSig.DkCoderProject) $ t)

(* Run command *)
let extractsig_cmd =
  let t =
    Term.(
      const ExtractSig.run $ copts_t $ scan_t $ outfile_t $ chdir_t $ pretty_t
      $ json_t)
  in
  let man =
    [
      `P
        "The current directory or the --change-directory directory (if \
         specified) will be scanned for libraries. The --scan option \
         influences which libraries are scanned for `.cmi` files.";
      `S "Security Design";
      `P
        "Any basename of a `.cmi` file that contains a double underscore (__) \
         like `DkHelloScript_Std__N1xxShell__Example100.cmi` is used for \
         analysis but not placed in the signature file.";
      `P "Why?";
      `P
        "These double underscore .cmi files are typically generated by Dune to \
         produce a flattened view of a nested module file like \
         `DkHelloScript_Std/N1xxShell/Example100.ml`. Since a flattened double \
         underscore module file may contain sub-modules, the module file must \
         be scanned. However, the double underscore is never allowed in user \
         code so they will not be placed in the signature file.";
      `P
        "This double underscore behavior is an important $(b,security feature) \
         of DkCoder since we can say that all nested module access has to go \
         through the dotted toplevel method like `A.B.C` rather than the \
         `A__B__C` direct method. The direct method has two flaws:";
      `P "1. It bypasses the libcontrols";
      `P
        "2. It makes two different ways to access the module, making it harder \
         to prove correctness in the DkCoder module analysis.";
      `S "Option: --scan DkCoderProject";
      `P
        "This scan option creates a codept signature file for all .cmi in all \
         `sig/` child directories. That is, `*/sig/*.cmi`. The `.cmi` files \
         may contain double underscores (__) in the filenames.";
      `P
        "The typical usage pattern is to set --change-directory to the \
         `share/` folder of a DkCoder build directory after the project has \
         been compiled. The `./dk DkDev_Std.ExtractSignatures` does this on \
         your behalf.";
      `S "Option: --scan DkCoderRuntime";
      `P
        "Only DkSDK subscribers who have been in contact with DkSDK Support \
         should use this scan option.";
      `P
        "The typical usage pattern is to set --change-directory to an opam \
         switch's `lib` directory. The opam switch must contain the DkCoder \
         Runtime packages like `Tr1Stdlib_V414Base`. The `.cmi` files that \
         contain double underscores (__) in the filenames are skipped.";
    ]
  in
  let doc =
    Fmt.str "Create a signature (.sig) file for the codept analysis tool."
  in
  Cmd.v (Cmd.info ~man ~doc "codept-lib-dkcodersig") t

(* Run CLI *)
let () = exit (Cmd.eval extractsig_cmd)
